name: "[OPTIONAL/DOESN'T BLOCK MERGING] Code Insights GitHub project automation"

on:
  issues:
    types: [opened, closed, reopened, milestoned, labeled]
  pull_request:
    types: [opened, edited, synchronize, ready_for_review, converted_to_draft]

jobs:
  update-project-items:
    name: Update project items
    runs-on: ubuntu-latest
    steps:
      - uses: actions/checkout@v2
      - name: Update project items
        uses: Amadevus/pwsh-script@v2
        env:
          GITHUB_TOKEN: ${{ secrets.GH_PROJECTS_ACTION_TOKEN }}
          SLACK_WEBHOOK_URI: ${{ secrets.INSIGHTS_ITERATION_SLACKBOT_WEBHOOK_URI }}
        with:
          script: |
            $InformationPreference = 'Continue'
            $ProgressPreference = 'SilentlyContinue'
            $ErrorActionPreference = 'Stop'
            Set-StrictMode -Version 3.0

            Install-Module PSGitHub -Force
            Install-Module PSSlack -Force

            if (!$env:GITHUB_TOKEN) {
              throw "No GITHUB_TOKEN env var provided"
            }

            $PSDefaultParameterValues['*GitHub*:Token'] = ConvertTo-SecureString -String $env:GITHUB_TOKEN -AsPlainText -Force

            ./.github/workflows/update-project-items.ps1 -ProjectNodeId 'MDExOlByb2plY3ROZXh0MzI3Ng==' -TeamLabel 'team/code-insights' -SlackChannel '#code-insights-planning' -SlackWebhookUri $env:SLACK_WEBHOOK_URI
